/**
 * Klasa Lavirint sadrzi 2 javne i jednu privatnu metodu za trazenje puteva.
 * 
 */

public class Lavirint {

 // Polje m sadrzi kompletnu mapu
 private Mapa m;

 // Ucitava mapu iz datog fajla i stampa je na ekran
 Lavirint(String imeFajla) {
  m = Mapa.ucitajIzFajla(imeFajla);
  m.stampaj();
 }

 // Provarava da li postoji put do izlaza i vraca vrednost true
 // ako postoji put ili vrednost false ako ne postoji
 public boolean postojiPut(int x, int y) {
  if (x < 0 || x >= m.getSirina() || y < 0 || y >= m.getVisina()) {
   return false;
  }
  if (m.getPos(x, y) == true) {
   return false;
  }
  if (m.getMat(x, y) == Mapa.ZID) {
   return false;
  }
  if (m.getMat(x, y) == Mapa.IZLAZ) {
   return true;
  } else {
   m.setPos(x, y, true);
   if (postojiPut(x + 1, y)) {
    return true;
   }
   if (postojiPut(x - 1, y)) {
    return true;
   }
   if (postojiPut(x, y + 1)) {
    return true;
   }
   if (postojiPut(x, y - 1)) {
    return true;
   }
   m.setPos(x, y, false);
   return false;
  }
 }

 // Poziva metodu rput da pronadje i ispise put, ako postoji
 // Ukoliko put ne postoji, ispisuje poruku o gresci
 public void nadjiPut(int x, int y) {
  if (!rput(x, y)) {
   System.err.println("Ne postoji put");
  }
 }

 // Proverava da li postoji put korsiteci pretrazivanje sa vracanjem
 // Ukoliko se pronadje izlaz iz lavirinta, stampa se put u obrnutom
 // redosledu
 // Put se stampa pri povratku iz rekurzije
 private boolean rput(int x, int y) {
  if (x < 0 || x >= m.getSirina() || y < 0 || y >= m.getVisina()) {
   return false;
  }
  if (m.getPos(x, y)) {
   return false;
  }
  if (m.getMat(x, y) == Mapa.ZID) {
   return false;
  }
  if (m.getMat(x, y) == Mapa.IZLAZ) {
   System.out.println(x + " " + y);
   return true;
  } else {
   m.setPos(x, y, true);
   if (rput(x + 1, y) || rput(x, y + 1) || rput(x, y - 1)
     || rput(x - 1, y)) {
    System.out.println(x + " " + y);
    return true;
   }
   m.setPos(x, y, false);
   return false;
  }
 }
}
